program Slowsquare
  use sep
  use slowsquare_mod

  implicit none

  integer 				:: n1,n2,niter,n2out,stat,iter,test
  integer				:: iadj, i1, i2, isos, iver, ilint
  logical                               :: dips
  logical				:: adj, add, ver
  real 					:: d1,d2,o1,o2
  real					:: num,den,s
  real, dimension(:,:), allocatable	:: data, model, dip

  call sep_init()

  call from_history ("n1", n1)
  call from_history ("d1", d1)
  call from_history ("o1", o1)

  call from_history ("n2", n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2)

  call from_param( "adj",  iadj, 0);   adj  = (iadj==1)
  call from_param( "verb", iver, 1); ver = (iver==1)

  call to_history ("o1", o1)
  call to_history ("d1", d1)
  call to_history ("n1", n1)

  call to_history ("o2", o2)
  call to_history ("d2", d2)
  call to_history ("n2", n2)

  call to_history("verb", iver)

  dips = exist_file ("dip")

  call sep_close ()

write(0,*) "finished history"
   
  if (allocated (data) ) deallocate (data)
  if (allocated (model) ) deallocate (model)
  if (allocated (dip) ) deallocate (dip)
   
if (ver) write(0,*) "Version 0"

if (ver) write(0,*) "Reserving space ..."

  allocate (data(n1,n2), STAT=test)
	if(test /=0) call seperr("cant allocate data")
  allocate (model(n1,n2), STAT=test)
	if(test /=0) call seperr("cant allocate model")
  allocate (dip(n1,n2),  STAT=test)
	if(test /=0) call seperr("cant allocate dip")

if (ver) write(0,*) "Done reserving space ..."
if (ver) write(0,*) "Doing adj", adj

call sep_read (data)
call sep_read (dip,"dip")


call slowsquare_init(n2,n1,o2,o1,d2,d1,dip)

call slowsquare_lop(adj,add,data,model)

call sep_write (model)

deallocate( model, STAT=test)
if (test /=0) call seperr("cant deallocate model")
deallocate( data, STAT=test)
if (test /=0) call seperr("cant deallocate data")
deallocate( dip, STAT=test)
if (test /=0) call seperr("cant deallocate dip")

if (ver) write(0,*) "all done"

  call exit(0)
end program Slowsquare
