program Smoother
  use sep

  implicit none
  integer                            :: n1, window, i1, i2, halfwin, start, finish, num
  real                               :: sum
  real, dimension (:),   allocatable :: medvel, smoothvel

  call sep_init (SOURCE)
  call from_history (n1)


  allocate (medvel(n1), smoothvel(n1))
  call sep_read (medvel)
  call from_param ("window", window, 5)

  halfwin = (window - 1)/2

  do i1=1,n1
     num=0
     sum=0
     if (i1 <= halfwin) then
        start=1
        finish=i1+halfwin
        do i2=start,finish 
           sum = sum + medvel(i2)
           num = num + 1
        enddo
        smoothvel(i1) = sum/num
     elseif (i1 >= (n1-halfwin)) then
        start=i1-halfwin
        finish=n1
        do i2=start,finish 
           sum = sum + medvel(i2)
           num = num + 1
        enddo
        smoothvel(i1) = sum/num
     else
        start=i1-halfwin
        finish=i1+halfwin
        do i2=start,finish 
           sum = sum + medvel(i2)
           num = num + 1
        enddo
        smoothvel(i1) = sum/num
     endif
  enddo

  call sep_write (smoothvel)
  deallocate (smoothvel,medvel)
  call sep_close ()
end program Smoother



