program SynNewMedian
  use sep

  implicit none
  integer                            :: n1, n2, i1, i2, prev, test1, goodcount
  real                               :: temp, min, test2, minslow, maxslow
  real, dimension (:,:), allocatable :: vel
  real, dimension (:),   allocatable :: medvel, good

  call sep_init (SOURCE)
  call from_history (n1, n2)
  call sep_close ()

  allocate (vel(n1,n2), medvel(n1), good(n2))
  call sep_read (vel)

!need to add parameter to decide between m/s and km/s

  vel=1/vel
  maxslow=(5000)*(5000)                  !minimum slowness^2 of 5km/s
  minslow=(1450)*(1450)                 !maximum slowness^2 of 1.45km/s 
  write(0,*) "minslow= ", minslow
  write(0,*) "maxslow= ", maxslow
  do i1=1,n1
     good(:)=0
     goodcount=0

     do i2=1,n2
        if ((vel(i1,i2)>=minslow).AND.(vel(i1,i2)<=maxslow)) then
           goodcount = goodcount + 1
           good(goodcount)=vel(i1,i2)
        endif
     enddo

     if (goodcount==0) then
        if (i1==1) then
           medvel(i1)=minslow
        else
           medvel(i1)=medvel(i1-1)
        endif
        cycle
     endif

     if (goodcount==1) then
        medvel(i1)=good(1)
        cycle
     endif

     if (goodcount==2) then
        medvel(i1)= (good(1) + good(2))/2
        cycle
     endif

     min=good(1)
     do i2=2,goodcount
        temp=good(i2)
        if (temp < min) then
           good(i2)=min
           min=temp
        endif
     enddo
     good(1)=min                                !put minimum value first

     do i2=3,goodcount                          !sort the rest
        temp=good(i2)
        prev=i2-1
        if (temp < good(prev)) then
           good(i2) = good(prev)
           prev=prev-1
           do
              if (temp >= good(prev)) exit
              good(prev+1)=good(prev)
              prev=prev-1
           enddo
           good(prev+1)=temp
        endif
     enddo
     test1=goodcount/2
     test2=goodcount/2
     if (test1 == test2) then                   !get median value
           medvel(i1)= (good(test1)+good(test1+1))/2
     else
           medvel(i1)= good(test1+1)
     endif
  enddo

!  test1=n2/2
!  test2=n2/2
!write(0,*) "test1 ",test1
!write(0,*) "test2 ",test2

!  if (test1 == test2) then                         !get median value
!     do i1=1,n1
!        medvel(i1)= (vel(i1,test1)+vel(i1,test1+1))/2
!        write(0,*) vel(i1,test1),vel(i1,test1+1),medvel(i1)
!     enddo
!  else
!     do i1=1,n1
!        medvel(i1)= vel(i1,test1+1)
!     enddo
!  endif

!do i1=1,n1
!write(0,*) "medvel ",medvel(i1)
!enddo

  call sep_write (medvel)
!  call sep_write (vel)
  deallocate (vel,medvel,good)

end program SynNewMedian



