module slowsquare_mod
! Slowsquare transformation
  use sep
  implicit none
  integer, private :: nt,nx
  real, private :: t0,x0
  real, private :: dt,dx 
  real, save, pointer, private :: dip(:,:)
  contains

  subroutine slowsquare_init (n2_in,n1_in,o2_in,o1_in,d2_in,d1_in,ang)

    real    :: o1_in,o2_in,d2_in,d1_in  
    integer :: n1_in,n2_in 
    real, target :: ang(:,:)

    t0 = o1_in; dt = d1_in; nt = n1_in
    x0 = o2_in; dx = d2_in; nx = n2_in

    dip => ang

  end subroutine


  subroutine slowsquare_lop( adj,add,tt,ss )

    logical,intent(in) :: adj,add 
    real, dimension(:,:), intent(in   )  :: tt
    real, dimension(:,:), intent(  out)  :: ss
    integer :: it, ix
    real    ::  x, t, s2, p, eps, temp

    temp = minval (abs(dip))	
    eps = 0.00001	
    write(0,*) "temp",temp, eps

    do ix = 1, nx
       do it = 1, nt
          dip(it,ix) = dip(it,ix) * dt / dx
       end do
    end do

    do ix= 1, nx  
      x = x0 + dx*(ix-1)
	do it= 1, nt
	  t = t0 + dt*(it-1)
	  p = dip(it,ix)
	  s2 = (t/x) * p
	  ss(it,ix) = s2
	end do
    end do

  end subroutine


  subroutine slowsquare_clear()

  end subroutine 


end module 
